<?php
/**
 * Страница настроек в панели администратора
 */

if (! defined('ABSPATH')) {
    exit;
}




if (! class_exists('KC2008_options_page')) {
    class KC2008_options_page
    {
        protected static $_instance = null;

        public static function instance()
        {
            if (is_null(self::$_instance)) {
                self::$_instance = new self();
            }
            return self::$_instance;
        }

        public function __construct()
        {
            add_action('wp_enqueue_scripts', array($this, 'ks2008_scripts'));
            add_action('admin_enqueue_scripts', array($this, 'ks2008_admin_scripts'));
			add_filter( 'pre_update_option_KC2008_delivery_option', 'myplugin_update_field_KC2008_delivery_option', 10, 3 );
			function myplugin_update_field_KC2008_delivery_option(   $value, $option, $old_value ) {
   
			if(!empty($value['login']) && !empty($value['code']) && !empty($value['password'])){
			require_once('class/MeasoftCourier.php'); 
				$measoft = new MeasoftCourier($value['login'], $value['password'], $value['code']);
				$client_code = $measoft->client_code();
				$value['client_code']=$client_code;
				
			}
			return $value;
				
}
        }

        /**
         * Подключение скриптов, стилей и вывод необходимых переменных для js
         */
        public function ks2008_scripts($hook)
        {
			if(!is_checkout() && !is_cart()) return true;
            wp_localize_script(
                'jquery',
                'myajax',
                array(
                    'url' => admin_url('admin-ajax.php'),
                    'nonce' => wp_create_nonce('myajax-nonce')
                )
            );

            global $woocommerce;
			
			 // здесь нужно получить кг в любом случае
            if ($woocommerce->cart->cart_contents_weight) {
                $ksweight = $woocommerce->cart->cart_contents_weight;
            } elseif (get_option('KC2008_delivery_option')['KC2008_weight']) {
                $ksweight = get_option('KC2008_delivery_option')['KC2008_weight'];
            } else {
                $ksweight = KC2008_delivery_plugin::getDefaultWeight();
            }
			
			$ksweight /= KC2008_delivery_plugin::getWeightDelimiter();
			
			
			

            wp_localize_script(
                'jquery',
                'ks2008client',
                array(
                    'id' => get_option('KC2008_delivery_option')['code'],
					'code' => get_option('KC2008_delivery_option')['client_code'],
                    'map_width' => get_option('KC2008_delivery_option')['map_width'],
                    'map_height' => get_option('KC2008_delivery_option')['map_height'],
                    'weight' => $ksweight,
					'saving' => __('Saving...', MEASOFT_PLUGIN_DOMAIN),
					'choosepickuppoint' => __('Choose pickup point', MEASOFT_PLUGIN_DOMAIN),
					'field3snotempty' => __('The fileds Login, Password, Service Client must not be empty', MEASOFT_PLUGIN_DOMAIN),
					'checking' => __('Checking...', MEASOFT_PLUGIN_DOMAIN),
					'success' => __('Success', MEASOFT_PLUGIN_DOMAIN),
					'error' => __('Error', MEASOFT_PLUGIN_DOMAIN),
					'error_town' => __('Error: Delivery town not set', MEASOFT_PLUGIN_DOMAIN),
					'error_weight' => __('Error: Delivery weight not set', MEASOFT_PLUGIN_DOMAIN),
					'error_town_sender' => __('Error: Sender town not set', MEASOFT_PLUGIN_DOMAIN),
					'calculating' => __('Calculating', MEASOFT_PLUGIN_DOMAIN),
					'error_weekend' => __('We can\'t create order on weekend', MEASOFT_PLUGIN_DOMAIN),
					'error_price' => __('Delivery price not set', MEASOFT_PLUGIN_DOMAIN),
					'error_delivery_date' => __('Delivery date not set', MEASOFT_PLUGIN_DOMAIN),
					'error_delivery_time_from' => __('Delivery time to not set', MEASOFT_PLUGIN_DOMAIN),
					'error_delivery_time_to' => __('Delivery time from not set', MEASOFT_PLUGIN_DOMAIN),
					'error_number_order' => __('Order number date not set', MEASOFT_PLUGIN_DOMAIN),
					'sending' => __('Sending...', MEASOFT_PLUGIN_DOMAIN),
					'order_n' => __('Order #', MEASOFT_PLUGIN_DOMAIN),
					'order_s' => __('has send', MEASOFT_PLUGIN_DOMAIN),
					
					
				
                )
            );
            wp_enqueue_style('KC2008-clientside-css', plugins_url('css/KC2008-clientside-css.css', __FILE__));

            if(is_checkout()) {
                wp_enqueue_style('measoft-checkout-css', plugins_url('css/checkout.css', __FILE__));
            }

            // wp_enqueue_script('KC2008-measoft-map-script', 'https://test.courierexe.ru/map_test_lightbox.html', array('jquery'), KC2008_PLUGIN_VERSION, 1 );
            wp_enqueue_script('KC2008-measoft-map-script', 'https://home.courierexe.ru/js/measoft_map.js', array('jquery'), KC2008_PLUGIN_VERSION, 1);

            //wp_enqueue_script('KC2008-measoft-map-script', plugins_url('js/measoft_map.js', __FILE__), array('jquery'), KC2008_PLUGIN_VERSION, 1);


            wp_enqueue_script('KC2008-delivery-script', plugins_url('js/scripts.js', __FILE__), array('jquery'), KC2008_PLUGIN_VERSION, 1);


            if (! wp_script_is('jquery-ui-autocomplete', 'enqueued')) {
                wp_enqueue_script('jquery-ui-autocomplete');
                wp_enqueue_style('jquery-ui-autocomplete-css', plugins_url('css/jquery.auto-complete.css', __FILE__),[],KC2008_PLUGIN_VERSION);
            }
        }

        /**
         * Подключение скриптов, стилей и вывод необходимых переменных для js в админ-панели
         */
        public function ks2008_admin_scripts()
        {
            wp_enqueue_script(
                'measoft-block-ui-script',
                plugins_url('js/block-ui.js', __FILE__),
                array('jquery'),
                KC2008_PLUGIN_VERSION,
                1
            );

            wp_enqueue_script(
                    'measoft-pay-script',
                    plugins_url('js/pay.js', __FILE__),
                    array('jquery'),
                    KC2008_PLUGIN_VERSION,
                    1
            );

            wp_enqueue_style(
                    'measoft-pay-style',
                    plugins_url('css/pay.css', __FILE__),
                    array(),
                    KC2008_PLUGIN_VERSION
            );
        }

        /**
         * Шаблон страницы настроек
         */
        public static function KC2008_delivery_set_template()
        { // delivery settings in admin panel
            $options = get_option('KC2008_delivery_option');

            if (function_exists('wc_get_order_statuses')) {
                $wc_statuses = wc_get_order_statuses();

                $api_statuses = array(
                    'NEW' => __('NEW', MEASOFT_PLUGIN_DOMAIN ),
                    'PICKUP' => __('PICKUP', MEASOFT_PLUGIN_DOMAIN ),
                    'ACCEPTED' => __('ACCEPTED', MEASOFT_PLUGIN_DOMAIN ),
                    'INVENTORY' => __('INVENTORY', MEASOFT_PLUGIN_DOMAIN ),
                    'DEPARTURING' => __('DEPARTURING', MEASOFT_PLUGIN_DOMAIN ),
                    'DEPARTURE' => __('DEPARTURE', MEASOFT_PLUGIN_DOMAIN ),
                    'DELIVERY' => __('DELIVERY', MEASOFT_PLUGIN_DOMAIN ),
                    'COURIERDELIVERED' => __('COURIERDELIVERED', MEASOFT_PLUGIN_DOMAIN ),
                    'COMPLETE' => __('COMPLETE', MEASOFT_PLUGIN_DOMAIN ),
                    'PARTIALLY' => __('PARTIALLY', MEASOFT_PLUGIN_DOMAIN ),
                    'COURIERRETURN' => __('COURIERRETURN', MEASOFT_PLUGIN_DOMAIN ),
                    'CANCELED' => __('CANCELED', MEASOFT_PLUGIN_DOMAIN ),
                    'RETURNING' => __('RETURNING', MEASOFT_PLUGIN_DOMAIN ),
                    'RETURNED' => __('RETURNED', MEASOFT_PLUGIN_DOMAIN ),
                    'CONFIRM' => __('CONFIRM', MEASOFT_PLUGIN_DOMAIN ),
                    'DATECHANGE' => __('DATECHANGE', MEASOFT_PLUGIN_DOMAIN ),
                    'NEWPICKUP' => __('NEWPICKUP', MEASOFT_PLUGIN_DOMAIN ),
                    'UNCONFIRM' => __('UNCONFIRM', MEASOFT_PLUGIN_DOMAIN ),
                    'PICKUPREADY' => __('PICKUPREADY', MEASOFT_PLUGIN_DOMAIN ),
                    'AWAITING_SYNC'=>__('AWAITING_SYNC', MEASOFT_PLUGIN_DOMAIN ),
                );
            }

            $measoft_service_list = new KC2008_order_api;  // get array for urgency delivery list
            $measoft_service_list = $measoft_service_list->get_service_list(); ?>
            <div>
                <h1><?php print __('KC2008 - Options', MEASOFT_PLUGIN_DOMAIN);?></h1>
                <form class="deliveryForm" method="post" action="options.php">
                    <?php settings_fields('KC2008_delivery_options_group'); ?>
                    <table class="form-table">
                        <tr>
                            <th scope="row">
                                <label for="delivery_option_login"><?php print __('Login', MEASOFT_PLUGIN_DOMAIN);?> <span>*</span></label>
                            </th>
                            <td>
                                <input autocomplete="off" class="delivery_option_login required" name="KC2008_delivery_option[login]" id="delivery_option_login" type="text" value="<?php echo (isset($options['login'])) ? $options['login'] : ''; ?>">
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                <label for="delivery_option_password"><?php print __('Password', MEASOFT_PLUGIN_DOMAIN);?> <span>*</span></label>
                            </th>
                            <td>
                                <input autocomplete="off" class="delivery_option_password required" name="KC2008_delivery_option[password]" id="delivery_option_password" type="password" value="<?php echo (isset($options['password'])) ? $options['password'] : ''; ?>">
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                <label for="delivery_option_code"><?php print __('Service client code', MEASOFT_PLUGIN_DOMAIN);?> <span>*</span></label>
                            </th>
                            <td>
                                <input autocomplete="off"  class="delivery_option_code required" name="KC2008_delivery_option[code]" id="delivery_option_code" type="text" value="<?php echo (isset($options['code'])) ? $options['code'] : ''; ?>">
								<input name="KC2008_delivery_option[client_code]" type="hidden" value="<?php echo (isset($options['client_code'])) ? $options['client_code'] : ''; ?>">
                            </td>
                        </tr>
                        <tr>
                            <th>
                                <span class="alertBlock"></span>
                            </th>
                            <td>
                                <div class="button delivery_option_test_call"><?php print __('Authorization checking', MEASOFT_PLUGIN_DOMAIN);?></div>
                            </td>
                        </tr>
                    </table>
                    <hr>
                    <table class="form-table">
                        <tr>
                            <th>
                                <label for="delivery_option_statuses"><?php print __('Status updating', MEASOFT_PLUGIN_DOMAIN);?></label>
                            </th>
                            <td>
                                <input id="delivery_option_statuses" type="checkbox" name="KC2008_delivery_option[statuses]" <?php echo (isset($options['statuses'])) ?  'checked' :  ''; ?>>
                                <p class="description"><?php print __('Put checkbox ON for getting status from KC2008', MEASOFT_PLUGIN_DOMAIN);?></p>
                            </td>
                        </tr>
						<tr>
                            <th>
                                <label for="auto_send_orders_measoft"><?php print __('Order autosending', MEASOFT_PLUGIN_DOMAIN);?></label>
                            </th>
                            <td>
                                <input id="auto_send_orders_measoft" type="checkbox" name="KC2008_delivery_option[autosend]" <?php echo (isset($options['autosend'])) ?  'checked' :  ''; ?>>
                                <p class="description"><?php print __('Put checkbox ON for autosending order to KC2008', MEASOFT_PLUGIN_DOMAIN);?></p>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">
                                <hr>
                            </td>
                        </tr>
                    </table>
                    <div class="tabsTabWrapper">
                        <div class="tabFormTable mainSettings active"><?php print __('General Options', MEASOFT_PLUGIN_DOMAIN);?></div>
                        <div class="tabFormTable orderStatusesSettings"><?php print __('Status additional options', MEASOFT_PLUGIN_DOMAIN);?></div>
                    </div>
                    <div class="tabsTableWrapper">
                        <table class="form-table active">
                            <tr>
                                <th>
                                    <label for="delivery_option_prefix"><?php print __('Prefix', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_prefix" type="text" name="KC2008_delivery_option[prefix]" value="<?php echo (isset($options['prefix'])) ? $options['prefix'] : ''; ?>">
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label for="delivery_option_size_num"><?php print __('Length', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_size_num" type="number" name="KC2008_delivery_option[size_num]" value="<?php echo (isset($options['size_num'])) ? $options['size_num'] : ''; ?>">
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label for="delivery_option_articles"><?php print __('Article using', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_articles" type="checkbox" name="KC2008_delivery_option[articles]" <?php echo (isset($options['articles'])) ?  'checked' :  ''; ?>>
                                    <p class="description"><?php print __('Put checkbox ON for sending item\'s article', MEASOFT_PLUGIN_DOMAIN);?></p>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label for="delivery_option_coefficient"><?php print __('Price koeficient value', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_coefficient" type="number" min="1" step="0.01" name="KC2008_delivery_option[coefficient]" value="<?php echo (isset($options['coefficient'])) ? $options['coefficient'] : '1'; ?>">
                                    <p class="description"><?php print __('"1" is minimal value', MEASOFT_PLUGIN_DOMAIN);?></p>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label for="delivery_option_add_cost"><?php print __('Price plus value', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_add_cost" class="required" type="number" min="0" step="0.01" name="KC2008_delivery_option[add_cost]" value="<?php echo (isset($options['add_cost'])) ? $options['add_cost'] : '0'; ?>">
                                    <p class="description"><?php print __('"0" is minimal value ', MEASOFT_PLUGIN_DOMAIN);?></p>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label for="delivery_option_default_weight"><?php print __('Default weight', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_default_weight" type="text" name="KC2008_delivery_option[KC2008_weight]" value="<?php echo (isset($options['KC2008_weight'])) ? $options['KC2008_weight'] : KC2008_delivery_plugin::getDefaultWeight(); ?>">&nbsp;<?php print (get_option( 'woocommerce_weight_unit')=='g' ? 'г' : 'кг') ;?>
                                    <p class="description"><?php print __('Default weight for item', MEASOFT_PLUGIN_DOMAIN);?></p>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label for="delivery_option_default_city"><?php print __('Sender town', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_default_city" class="required" type="text" name="KC2008_delivery_option[city]" value="<?php echo (isset($options['city'])) ? $options['city'] : ''; ?>">
                                    <p class="description"><?php print __('Start typing town name', MEASOFT_PLUGIN_DOMAIN);?></p>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label for="delivery_option_map_size"><?php print __('Map options', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <?php print __('Width', MEASOFT_PLUGIN_DOMAIN);?>: <input id="delivery_option_map_size" class="required" type="number" name="KC2008_delivery_option[map_width]" value="<?php echo (isset($options['map_width'])) ? $options['map_width'] : '650'; ?>">
                                    &nbsp;&nbsp;&nbsp;<?php print __('Height', MEASOFT_PLUGIN_DOMAIN);?>: <input id="delivery_option_map_size_h" class="required" type="number" name="KC2008_delivery_option[map_height]" value="<?php echo (isset($options['map_height'])) ? $options['map_height'] : '755'; ?>">
                                </td>
                            </tr>

                            <tr>
                                <th>
                                    <label for="delivery_option_map_size"><?php print __('Tariff', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <select name="KC2008_delivery_option[service_delivery]" id="delivery_option_service_delivery">
									 <option value=""><?php print __('None', MEASOFT_PLUGIN_DOMAIN);?></option>
                                        <?php foreach ($measoft_service_list as $service_delivery_item): ?>
                                            <?php if (isset($options['service_delivery']) && $options['service_delivery'] == $service_delivery_item['code']): ?>
                                                <option value="<?php echo $service_delivery_item['code']; ?>" selected><?php echo $service_delivery_item['name']; ?></option>
                                            <?php else: ?>
                                                <option value="<?php echo $service_delivery_item['code']; ?>"><?php echo $service_delivery_item['name']; ?></option>
                                            <?php endif; ?>
                                        <?php endforeach; ?>
                                    </select>
                                </td>
                            </tr>
							<tr>
                                <th>
                                    <label for="delivery_option_round"><?php print __('Round item quantity to integer', MEASOFT_PLUGIN_DOMAIN);?></label>
                                </th>
                                <td>
                                    <input id="delivery_option_round" type="checkbox" name="KC2008_delivery_option[rounding]" <?php echo (isset($options['rounding'])) ?  'checked' :  ''; ?>>
                                    <p class="description"><?php print __('Put checkbox ON for rounding item quantity to integer', MEASOFT_PLUGIN_DOMAIN);?></p>
                                </td>
                            </tr>
                        </table>
                        <table class="form-table">
                            <?php
                            if (isset($wc_statuses) && isset($api_statuses) && isset($options['statuses'])) {

                                foreach ($api_statuses as $key => $value) {
                                    $api_status_key = $key; ?>
                                    <tr>
                                        <th>
                                            <label for="delivery_option_status_<?php echo $key; ?>"><?php echo $value; ?></label>
                                        </th>
                                        <td>
                                            <select class="" name="KC2008_delivery_option[status_<?php echo $key; ?>]" id="delivery_option_status_<?php echo $key; ?>">
                                                <option value="0"><?php print __('No action', MEASOFT_PLUGIN_DOMAIN);?></option>
                                                <?php
                                                foreach ($wc_statuses as $key => $value) {
                                                    echo '<option value="'.$key.'"';
                                                    if (isset($options['status_'.$api_status_key])) {
                                                        if ($options['status_'.$api_status_key] == $key) {
                                                            echo " selected ";
                                                        }
                                                    } elseif ($api_status_key == 'COMPLETE' && $key == 'wc-completed') {
                                                        echo " selected ";
                                                    } elseif ($api_status_key == 'CANCELED' && $key == 'wc-cancelled') {
                                                        echo " selected ";
                                                    } elseif ($api_status_key == 'RETURNED' && $key == 'wc-refunded') {
                                                        echo " selected ";
                                                    } elseif ($api_status_key == 'UNCONFIRM' && $key == 'wc-failed') {
                                                        echo " selected ";
                                                    }
                                                    echo '>'.$value.'</option>';
                                                } ?>
                                            </select>
                                        </td>
                                    </tr>
                                <?php
                                }
                            } ?>
                        </table>
                    </div>

                    <?php submit_button(); ?>
                </form>

                <?php

                $measoft_pay_types = get_option('measoft_pay_types');
                $gateways = WC()->payment_gateways->payment_gateways();
                $enabled_gateways = [];

                if( $gateways ) {
                    foreach( $gateways as $gateway ) {

                        if( $gateway->enabled == 'yes' ) {
                            $type = '';

                            if( isset($measoft_pay_types['card']) && is_array($measoft_pay_types['card']) ) {
                                if(in_array($gateway->id, $measoft_pay_types['card'])) {
                                    $type = MeasoftCourier::PAYMENT_TYPE_CARD;
                                }
                            }

                            if( isset($measoft_pay_types['cash']) && is_array($measoft_pay_types['cash']) ) {
                                if(in_array($gateway->id, $measoft_pay_types['cash'])) {
                                    $type = MeasoftCourier::PAYMENT_TYPE_CASH;
                                }
                            }

                            if( isset($measoft_pay_types['no']) && is_array($measoft_pay_types['no']) ) {
                                if(in_array($gateway->id, $measoft_pay_types['no'])) {
                                    $type = MeasoftCourier::PAYMENT_TYPE_NONE;
                                }
                            }

                            $enabled_gateways[] = array(
                                'id'    => $gateway->id,
                                'title' => $gateway->title,
                                'type'  => $type
                            );

                        }
                    }
                }

                ?>

                <hr>

                <div class="measoft-pay-type">
                    <h2 class="measoft-pay-type__title">
                        <?= __( 'Payment methods', MEASOFT_PLUGIN_DOMAIN ) ?>>
                    </h2>

                    <form action="/" method="post" class="measoft-pay-type__form" id="measoftPayTypeForm">
                        <table class="measoft-pay-type__table wp-list-table widefat fixed striped table-view-list">
                            <thead>
                            <tr>
                                <th class="manage-column"><?php print __('Payment methods', MEASOFT_PLUGIN_DOMAIN);?></th>
                                <th class="manage-column"><?= MeasoftCourier::PAYMENT_TYPE_CARD ?></th>
                                <th class="manage-column"><?= MeasoftCourier::PAYMENT_TYPE_CASH ?></th>
                                <th class="manage-column"><?= MeasoftCourier::PAYMENT_TYPE_NONE ?></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php if( $enabled_gateways ) : ?>
                                <?php foreach( $enabled_gateways as $gateway ) : ?>
                                    <tr>
                                        <th><?= $gateway['title'] ?></th>
                                        <td>
                                            <input
                                                    type="radio"
                                                    name="measoft_pay_type[<?= $gateway['id'] ?>]"
                                                    value="<?= MeasoftCourier::PAYMENT_TYPE_CARD ?>"
                                                    <?= ($gateway['type'] === MeasoftCourier::PAYMENT_TYPE_CARD) ? 'checked' : '' ?>
                                            >
                                        </td>
                                        <td>
                                            <input
                                                    type="radio"
                                                    name="measoft_pay_type[<?= $gateway['id'] ?>]"
                                                    value="<?= MeasoftCourier::PAYMENT_TYPE_CASH ?>"
                                                    <?= ($gateway['type'] === MeasoftCourier::PAYMENT_TYPE_CASH) ? 'checked' : '' ?>
                                            >
                                        </td>
                                        <td>
                                            <input
                                                    type="radio"
                                                    name="measoft_pay_type[<?= $gateway['id'] ?>]"
                                                    value="<?= MeasoftCourier::PAYMENT_TYPE_NONE ?>"
                                                    <?= ($gateway['type'] === MeasoftCourier::PAYMENT_TYPE_NONE) ? 'checked' : '' ?>
                                            >
                                        </td>
                                    </tr>
                                <?php endforeach; ?>
                            <?php endif; ?>
                            </tbody>
                        </table>

                        <?php submit_button(
                            __('Save options', MEASOFT_PLUGIN_DOMAIN),
                            'primary',
                            'measoft_pay_type_submit'
                        ); ?>
                    </form>
                </div>

                <?php
                $cron_jobs = get_option('cron');
                $cron = false;
                foreach ($cron_jobs as $cron_job) {
                    if (is_array($cron_job)) {
                        foreach ($cron_job as $key => $value) {
                            if ($key == 'ks2008_hourly_event') {
                                $cron = true;
                            }
                        }
                    }
                } ?>
                <hr>
                <br>
                <?php
                $module_row = 0;
                global $wpdb;

                $ks2008_deliveryset_max = get_option('ks2008_deliveryset_max');
              
                ?>

                <table class="" style="width: auto;">
                    <tr>
                        <th>
                            <h2 style="text-align: left;"><?php print __('Free price option', MEASOFT_PLUGIN_DOMAIN);?></h2>
							<h3 style="text-align: left;"><?php print __('The sum of order for zero pricing', MEASOFT_PLUGIN_DOMAIN);?></h3>
                        </th>
                    </tr>
				</table>
				
                <form class="ks2008_deliveryset_form" method="post">
                <table class="form--table delivery_set-table" style="width: auto;">
               
				 <tr>
                        <td>
                            <input id="ks2008_differential_delivery_max" type="text" name="ks2008_differential_delivery_max" value="<?php echo htmlspecialchars(get_option('ks2008_differential_delivery_max')); ?>" >                           
                        </td>
                </tr>
                
                <tr>
                        <td><br /><input type="submit" name="" value="<?php print __('Save', MEASOFT_PLUGIN_DOMAIN);?>" class="button button-primary" id="ks2008_save_delivery"></td>
                    </tr>
                </table>

                <hr>
                <br>

                <table class="form-table cron-table" style="width: auto;">
                    <tr>
                        <th>
                            <label for="cron_jobs"><?php print __('Status sync', MEASOFT_PLUGIN_DOMAIN);?></label>
                        </th>
                        <td>
                            <?php
                            if ($cron) {
                                echo "<strong class='cron_text' style='color:green;'>".__('Active', MEASOFT_PLUGIN_DOMAIN)."</strong>";
                                echo "&nbsp;";
                                echo "&nbsp;";
                                echo "&nbsp;";
                                echo '<button type="button" name="cron_off" data-turn="off" class="button cron_turn">'.__('Turn Off', MEASOFT_PLUGIN_DOMAIN).'</button>';
                            } else {
                                echo "<strong class='cron_text' style='color:red;'>".__('Not active', MEASOFT_PLUGIN_DOMAIN)."</strong>";
                                echo "&nbsp;";
                                echo "&nbsp;";
                                echo "&nbsp;";
                                echo '<button type="button" name="cron_on" data-turn="on" class="button cron_turn">'.__('Turn On', MEASOFT_PLUGIN_DOMAIN).'</button>';
                            } ?>
                            <p class="description"><?php print __('Fucntion based on WP_Cron fucntion', MEASOFT_PLUGIN_DOMAIN);?></p>
                        </td>

                    </tr>

                </table>
                </form>
            </div>
           
            <?php
        }
    }
}


if (! function_exists('callTheTemplateClass')) {
    function callTheTemplateClass()
    {
        return KC2008_options_page::instance();
    }
}
callTheTemplateClass();
