<?php

if (! defined('ABSPATH')) {
    exit;
} // Exit if accessed directly

// if( WP_DEBUG && WP_DEBUG_DISPLAY && (defined('DOING_AJAX') && DOING_AJAX) ){ // catch ajax errors
// 	@ ini_set( 'display_errors', 1 );
// }

if (! class_exists('KC2008_order_api')) {
    class KC2008_order_api
    {
        public $options;
        public $measoft;

        public function __construct()
        {
            $this->options = get_option('KC2008_delivery_option');
			if(!$this->options || !is_array($this->options)){
				$this->options = [
					'login' => '',
					'password' => '',
					'code' => '',
				];
			}
            $this->measoft = new MeasoftCourier($this->options['login'], $this->options['password'], $this->options['code']);
			
			add_action('woocommerce_checkout_create_order', array($this, 'check_new_order_shipping'), 10, 2); // Проверка, что выбран ПВЗ для Самовывоза
			add_action('woocommerce_thankyou', array($this, 'check_new_order_ok_shipping')); // обнуляем сессию
			add_action('woocommerce_checkout_update_order_meta', array($this, 'woocommerce_new_order_measoft'), 99, 2); // автоотправка заказа
			add_filter('woocommerce_cart_shipping_packages', array($this, 'measoft_woocommerce_shipping_rate_cache_invalidation'), 100); // cache
			

            if (wp_doing_ajax()) {
                add_action('wp_ajax_query_create_order', array($this, 'query_create_order')); // Функция создания заказа по аякс

                add_action('wp_ajax_ks2008_city_autocomplete', array($this, 'ks2008_city_autocomplete')); // Функция автодополнения города
                add_action('wp_ajax_nopriv_ks2008_city_autocomplete', array($this, 'ks2008_city_autocomplete'));

                add_action('wp_ajax_ks2008_adress_autocomplete', array($this, 'ks2008_adress_autocomplete')); // Функция автодополнения улицы
                add_action('wp_ajax_nopriv_ks2008_adress_autocomplete', array($this, 'ks2008_adress_autocomplete'));

                add_action('wp_ajax_ks2008_deliveryprice_calculate', array($this, 'ks2008_deliveryprice_calculate')); // Функция рассчета стоимости заказа в админке
                add_action('wp_ajax_nopriv_ks2008_deliveryprice_calculate', array($this, 'ks2008_deliveryprice_calculate'));

                add_action('wp_ajax_query_authorization', array($this, 'query_authorization')); // Функция проверки авторизации
                add_action('wp_ajax_ks2008_cron_turn', array($this, 'ks2008_cron_turn')); // Функция включения/выключения крон задачи
                add_action('wp_ajax_ks2008_save_delivery', array($this, 'ks2008_save_delivery')); // Функция сохранения настроек для блока deliveryset


                add_action('wp_ajax_ks2008_recalc', array($this, 'ks2008_recalc')); // ajax функция из callback карты
				add_action('wp_ajax_nopriv_ks2008_recalc', array($this, 'ks2008_recalc')); // ajax функция из callback карты
                add_action('woocommerce_checkout_update_order_review', array($this,'action_woocommerce_checkout_update_order_review'), 10, 2); // триггер на апдейт корзины
				add_action('woocommerce_nopriv_checkout_update_order_review', array($this,'action_woocommerce_checkout_update_order_review'), 10, 2); // триггер на апдейт корзины
			


            }
        }
		
		public function measoft_woocommerce_shipping_rate_cache_invalidation( $packages ) {
			
			foreach ( $packages as &$package ) {
				$package['rate_cache'] = wp_rand();
			}

			return $packages;
		}
		
		public function woocommerce_new_order_measoft($order_id)
		{			
			$order = wc_get_order($order_id);
			
			if((isset($this->options['autosend']) && $this->options['autosend'] == 'on' ) && ($order->has_shipping_method('KC2008_Pickup_Method') || $order->has_shipping_method('KC2008_shipping_courier_method'))) { 
				
				$post = KC2008_delivery_plugin::getDataForMeasoft($order, $this->measoft, $this->options, $order_id);
				self::send_order_measoft($order, $this->options, $post, $this->measoft, true);
				
			}		
		}
		
            

        /**
         * Функция вызывается как callback['choicePvzCallback'] 
         * из функции "measoftCallRecalc" в scripts.js [72 строка], 
         * @return (integer) итоговая стоимость (тариф) для выбранного ПВЗ
         */
          public function ks2008_recalc()
          {
               $pvzData = $_POST['pvzData'];
               			   
			   if(!empty($pvzData['code'])){
					$measoftpvzCode = sanitize_text_field($pvzData['code']);
					$measoftpvzAddress = sanitize_text_field($pvzData['address']);
					WC()->session->set( 'measoftpvzCode', $measoftpvzCode );   
					WC()->session->set( 'measoftpvzAddress', $measoftpvzAddress );   
			   }
			   


               wp_die();
          }

          function action_woocommerce_checkout_update_order_review($array, $int)
          {
              WC()->cart->calculate_shipping();
              WC()->cart->calculate_totals();
              return;
          }

        public function ks2008_save_delivery()
        {
            $ks2008_differential_delivery_max = isset($_POST['ks2008_differential_delivery_max']) ? $_POST['ks2008_differential_delivery_max'] : '';           
            $res = update_option('ks2008_differential_delivery_max', $ks2008_differential_delivery_max);
			wp_send_json_success(__('Updated successfully', MEASOFT_PLUGIN_DOMAIN));
          
        }

        public function ks2008_cron_turn()
        {
            $turn = $_POST['turn'];
            $json = array();
            if ($turn == 'on') {
                $res = wp_schedule_event(time(), 'every_30min', 'ks2008_hourly_event');
                $json['text'] = __('Turn Off', MEASOFT_PLUGIN_DOMAIN);
                $json['attr'] = 'off';
                $json['ctext'] = __('Active', MEASOFT_PLUGIN_DOMAIN);
                $json['color'] = 'green';
                $json['res'] = $res;
            } elseif ($turn == 'off') {
                $res = wp_clear_scheduled_hook('ks2008_hourly_event');
                $json['text'] = __('Turn On', MEASOFT_PLUGIN_DOMAIN);
                $json['attr'] = 'on';
                $json['ctext'] = __('Not active', MEASOFT_PLUGIN_DOMAIN);
                $json['color'] = 'red';
                $json['res'] = $res;
            } else {
                wp_send_json_error(__('Error', MEASOFT_PLUGIN_DOMAIN));
            }

            if ($res) {
                wp_send_json_success($json);
            } else {
                wp_send_json_error(__('Error', MEASOFT_PLUGIN_DOMAIN));
            }
        }

        public function query_authorization()
        {
            $delivery_option_login =  $_POST['delivery_option_login'];
            $delivery_option_password =  $_POST['delivery_option_password'];
            $delivery_option_code =  $_POST['delivery_option_code'];

            $measoft = new MeasoftCourier($delivery_option_login, $delivery_option_password, $delivery_option_code);

            try {
                $res = $measoft->orderStatus('1235900');
                if ($res == 'authorization_error') {
                    wp_send_json_error(__('Authorization error', MEASOFT_PLUGIN_DOMAIN));
                } else {
                    wp_send_json_success($res);
                }
            } catch (Exception $e) {
                wp_send_json_success(__('Error', MEASOFT_PLUGIN_DOMAIN));
            }

            wp_die();
        }

        public function get_service_list()
        {
            $delivery_option_login =  $this->options['login'];
            $delivery_option_password =  $this->options['password'];
            $delivery_option_code =  $this->options['code'];

            $measoft = new MeasoftCourier($delivery_option_login, $delivery_option_password, $delivery_option_code);

            $get_sevices_statuses = $measoft->getServiceList();

            return $get_sevices_statuses;
        }

        public function ks2008_deliveryprice_calculate()
        {
			
            $townfrom = $_POST['townfrom'];
            $townto = $_POST['townto'];
            $mass = $_POST['mass'];
            $pvzcode = $_POST['pvzcode'];
			$order_total = $_POST['order_total'];
			$shipping_address = $_POST['shipping_address'];	
			$paytype = $_POST['paytype'];	
			$packages = stripslashes($_POST['_packages']);	
			$json_error = '';
			$packages = json_decode($packages,1);
				
			if (empty($townto)) {
                 wp_send_json_error();
            }

            try {
				   
				    $req = ['order'=>[
                                    'sender' => ['town' => $townfrom], // +
									'receiver' => ['town' => $townto, 'address' => $shipping_address],          // +                        
                                    'weight' => $mass, // +
                                    'service' => isset($options['service_delivery']) ? $options['service_delivery'] : 1, // +
                                    'pricetype' => 'CUSTOMER', // +
									'paytype' => $paytype, // +
                                    'price' => $order_total, // +
                                    'insprice' => $order_total, // +
                                    'packages' => ['package' => $packages],
                            ]];
							 if (!empty($pvzcode)) {
                                    $req['order']['receiver']['pvz'] = $pvzcode;
							 }
								
                       $res = $this->measoft->calculate($req, true);
               } catch (\Exception $e) {
                    $res = false;
                    $json_error = $e->getMessage();
               }

               if ($res) {
                    $res = (float)$res * (float)$this->options['coefficient'] + (float)$this->options['add_cost'];
                    wp_send_json_success($res);
               } else {
                    wp_send_json_error($json_error);
               } 
               wp_die();
        }

        public function object2array($object)
        {
            return @json_decode(@json_encode($object), 1);
        }

        public function ks2008_adress_autocomplete()
        {
            $json_error = '';

            $term = $_POST['search']['term'];
            $town = $_POST['town'];

            $street_search = ['town' => $town, 'namestarts' => $term, ];
            $street_search2 = ['town' => $town, 'namecontains' => $term, ];

            try {
                $response = $this->measoft->streetsList($street_search);
            } catch (\Exception $e) {
                $response = false;
                $json_error = $e->getMessage();
            }

            try {
                $response2 = $this->measoft->streetsList($street_search2);
            } catch (\Exception $e) {
                $response2 = false;
                $json_error = $e->getMessage();
            }

            $streets_arr = array();

            if ($response) {
                foreach ($response->street as $street) {
                    $streets_arr[] = $this->object2array($street->name)[0];
                }
            }
            if ($response2) {
                foreach ($response2->street as $street) {
                    $streets_arr[] = $this->object2array($street->name)[0];
                }
            }

            if (!$response && !$response2) {
                $streets_arr[] = __('Street not found', MEASOFT_PLUGIN_DOMAIN) ;
            }

            if (!$town) {
                $streets_arr[] = __('The town is empty', MEASOFT_PLUGIN_DOMAIN);
            }

            wp_send_json_success($streets_arr);

            wp_die();
        }

        public function ks2008_city_autocomplete()
        {
            $term = $_POST['search']['term'];

            $json_error = '';

            $city_search = ['namecontains' => $term];
            try {
                $response = $this->measoft->citiesList($city_search);
            } catch (\Exception $e) {
                $response = false;
                $json_error = $e->getMessage();
            }

            $cities_arr = array();

            if ($response) {
                foreach ($response as $city) {
                    $cities_arr[] = $city['name'];
                }
            } else {
                $cities_arr[] = __('Town is not found', MEASOFT_PLUGIN_DOMAIN);
            }
            wp_send_json_success($cities_arr);

            wp_die();
        }

		public function check_new_order_ok_shipping()
		{
			WC()->session->set( 'cost_for_pvz', 0);
			WC()->session->set( 'measoftpvzCode', 0);			
			WC()->session->set( 'measoftpvzAddress', '');
			WC()->session->set( 'measoftpvzPrice', false);
						
		}
		public function check_new_order_shipping($order, $data)
        {
			$shipping_method = @array_shift($order->get_shipping_methods());
			$shipping_method_id = $shipping_method['method_id'];
			$measoftpvzCode = WC()->session->get( 'measoftpvzCode');								
			$shipping_total = $order->get_shipping_total();
			$error_text='';	
			
			$measoftpvzPriceFound = WC()->session->get('measoftpvzPrice');
			
			
			if ($shipping_method_id == 'KC2008_Pickup_Method'){
				if(empty($measoftpvzCode)){
					$error_text = __('Please choose a pickup point', MEASOFT_PLUGIN_DOMAIN); 
				}
				if(empty($measoftpvzPriceFound) && empty($shipping_total)){
					$error_text = __('Price is not found', MEASOFT_PLUGIN_DOMAIN); 	
				}
				
				if(!empty($error_text)){
					throw new Exception( $error_text );						
				}				
				
			}
        
		}
		
		private static function addOrderNoteError($order, $error){
			$order->add_order_note(__('Autosend order error is ', MEASOFT_PLUGIN_DOMAIN) . $error);
			return true;
		}
		
		public static function send_order_measoft($order, $options, $data, $measoft, $auto = false){
			
			$params = array();
            $measoft_items = array();
            $formData = array();
			
            $order_data = $order->get_data();

            ## SHIPPING INFORMATION:

            $order_shipping_first_name = $order_data['shipping']['first_name'];
            $order_shipping_last_name = $order_data['shipping']['last_name'];
            $order_shipping_city = $order_data['shipping']['city'];
            $order_shipping_address_1 = $order_data['shipping']['address_1'];
            $order_shipping_address_2 = $order_data['shipping']['address_2'];
            $order_shipping_postcode = $order_data['shipping']['postcode'];

            ## BILLING INFORMATION:

            $order_billing_first_name = $order_data['billing']['first_name'];
            $order_billing_last_name = $order_data['billing']['last_name'];
            $order_billing_phone = $order_data['billing']['phone'];
            $order_billing_city = $order_data['billing']['city'];
            $order_billing_address_1 = $order_data['billing']['address_1'];
            $order_billing_address_2 = $order_data['billing']['address_2'];
            $order_billing_postcode = $order_data['billing']['postcode'];


            $zipcode = $order_shipping_postcode ? $order_shipping_postcode : $order_billing_postcode;
            $snf = $order_shipping_first_name ? $order_shipping_first_name . ' ' . $order_shipping_last_name : $order_billing_first_name . ' ' . $order_billing_last_name;
            $phone = $order_billing_phone ? $order_billing_phone : '';
            $city = $order_shipping_city ? $order_shipping_city : $order_billing_city;

            if (isset($data['pvz_adress']) && !empty($data['pvz_adress'])) {
                $address = $data['pvz_adress'];
            } else {
                $address = $order_shipping_address_1 ? $order_shipping_address_1 . ' ' . $order_shipping_address_2 : $order_billing_address_1 . ' ' . $order_billing_address_2;
            }

            $total_weight = 0;
			$counter=0;
			$default_weight = !empty($options['KC2008_weight']) ? $options['KC2008_weight'] : KC2008_delivery_plugin::getDefaultWeight(); 
            foreach ($order->get_items() as $item_key => $item):
			
				$product        = $item->get_product();
					
                if (!empty($product) && isset($options['articles'])) {                    
					
                    $product_sku    = $product->get_sku();
                    $quantity       = $item->get_quantity();
                    try {
                        $product_data = $measoft->productGetByArticle($product_sku);
                    } catch (\Exception $e) {
                        $json_error = $e->getMessage();
						if(!$auto){
							wp_send_json_error($json_error);
							wp_die();	
						} else {
							self::addOrderNoteError($order, $json_error);
							return true;
						}
                        
                    }

                    if ($product_data->attributes()->{'count'} == 0) {
						$text = __('Items not found', MEASOFT_PLUGIN_DOMAIN);
						if(!$auto){
							wp_send_json_error($text);
							wp_die();
						} else {
							self::addOrderNoteError($order, $text);
							return true;
						}
                    }

                    $product_name = $product_data->item->name;
                    $line_total   = $product_data->item->retprice;
                    $product_weight  = $product_data->item->weight;

                    // dimensions
                    $product_length = $product_data->item->length;
                    $product_width = $product_data->item->width;
                    $product_height = $product_data->item->height;
                } else {
                    $item_id = $item->get_id();

                 

                    $product_name = $item->get_name();
                    $quantity     = $item->get_quantity();
					

               

                    $line_total  = $order->get_item_total( $item, true, false );

                 
                    $product_weight  = empty($product) ? 0 : (float)$product->get_weight();

                    // dimensions
                    $product_length = empty($product) ? '' : $product->get_length();
                    $product_width = empty($product) ? '' : $product->get_width();
                    $product_height = empty($product) ? '' : $product->get_height();
                }
					
				if(!empty($options['rounding'])) $quantity = max(round($quantity), 1);
				
				if(empty($product_weight)) $product_weight = $default_weight;               
                $total_weight += (float)$product_weight * (int)$quantity;
               

                if (!empty($product) && isset($options['articles'])) {
                    $measoft_items[$counter] = array(
                            'name' => $product_name,
                            'quantity' => $quantity,                        
                            'retprice' => $line_total,
                            'article' => $product_sku,
                            'barcode' => '',
                        );
                } else {
                    $measoft_items[$counter] = array(
                            'name' => $product_name,
                            'quantity' => $quantity,
                            'mass' => $product_weight,
                            'retprice' => $line_total,
                            'barcode' => '',
                        );
                }
                if ($product_length) {
                    $measoft_items[$counter]['length'] = $product_length;
                }
                if ($product_width) {
                    $measoft_items[$counter]['width'] = $product_width;
                }
                if ($product_height) {
                    $measoft_items[$counter]['height'] = $product_height;
                }
				
				$counter++;

            endforeach;

			if(empty($total_weight)) $total_weight = $default_weight;
        
            $measoft_order = array(
                'receiver' => array(
                    'person' => $snf,
                    'phone' => $phone,
                    'zipcode' => $zipcode,
                    'address' => $address,
                    'town' => $city,
                    'date' => $data['delivery_date'],
                    'time_min' => $data['delivery_time_from'],
                    'time_max' => $data['delivery_time_to'],
                ),
                'paytype' => $data['pay_type'],
                'price' => $order->get_total(),
				'inshprice' => $order->get_total(),
                'deliveryprice' => $data['deliveryprice'],
                'orderno' => $data['orderno'],
                'weight' => $total_weight,
                'enclosure' => $data['enclosure'],
                'instruction' => $data['instruction'],
                'service' => !empty($options['service_delivery']) ? $options['service_delivery'] : 1,
                'return' => false,
            );

            if (isset($data['pvz']) && !empty($data['pvz'])) {
                $measoft_order['receiver']['pvz'] = $data['pvz'];
            } 

           

            $json_success = array();
            $json_error = array();
		
            try {
                $res = $measoft->orderCreate($measoft_order, $measoft_items);
                $json_success['orderno'] = $res;
            } catch (\Exception $e) {
                $res = false;
                $json_error = $e->getMessage();
            }
			
            if ($res && !isset($res['error'])) {				
				try {
                    $check_order = $measoft->orderStatus($res);
                } catch (\Exception $e) {					
                    $check_order = false;
                    $json_error = $e->getMessage();
                }
				

                if ($check_order && $check_order != __('Order #', MEASOFT_PLUGIN_DOMAIN).$data['post_id'].__(' not found', MEASOFT_PLUGIN_DOMAIN)) {	
                    $json_success['status'] = $check_order;
                    $order->update_meta_data('KC2008_order_number', $res);
                    $order->update_meta_data('KC2008_order_status', $check_order);					
					$order->save_meta_data();
                    $note = __('Order created. Status is ', MEASOFT_PLUGIN_DOMAIN).$check_order;
                    $order->add_order_note($note);

                    add_filter('woocommerce_order_get_items', 'custom_order_get_items', 10, 3);
                    function custom_order_get_items($items, $order, $types)
                    {
                        if (is_admin() && $types == array('shipping')) {
                            $items = array();
                        }
                        return $items;
                    }
					
					if(!$auto)
						wp_send_json_success($json_success);
                } else {	

					if(!$auto){	
						wp_send_json_error($json_error);
					}else{
						self::addOrderNoteError($order, $json_error);
					}
						
                }
            } else {
				
				
				if(!$auto){	
					wp_send_json_error((string)$res['error']->createorder[0]['errormsgru']);
				}else{				
					self::addOrderNoteError($order, (string)$res['error']->createorder[0]['errormsgru']);				
					
				}
            }
			if(!$auto)
				wp_die();
			else	
				return true;
		
		}

        public function query_create_order()
        {  
            $order = wc_get_order($_POST['post_id']);
			self::send_order_measoft($order, $this->options, $_POST, $this->measoft);			
        }
    }

    return new KC2008_order_api();
}
