<?php


class MeasoftAjaxController
{
    public function init()
    {
        $this->initAction();
        $this->initAdminAction();
    }

    private function initAction()
    {

    }

    private function initAdminAction()
    {
        add_action( 'wp_ajax_measoft_pay_type_save', [$this, 'savePayType'] );
        add_action( 'wp_ajax_measoft_pay_type_set', [$this, 'setPayType'] );
        add_action( 'wp_ajax_nopriv_measoft_pay_type_set', [$this, 'setPayType'] );
    }

    public function savePayType()
    {
        $form_data = isset($_POST['formData']) ? $_POST['formData'] : null;

        if( !empty($form_data) ) {
            $params = [];
            parse_str($form_data, $params);

            $card_pay = [];
            $cash_pay = [];
            $none_pay = [];

            if( !empty($params['measoft_pay_type']) ) {
                foreach ( $params['measoft_pay_type'] as $key => $value ) {
                    if($value === MeasoftCourier::PAYMENT_TYPE_CARD) {
                        $card_pay[] = $key;
                    }

                    if($value === MeasoftCourier::PAYMENT_TYPE_CASH) {
                        $cash_pay[] = $key;
                    }

                    if($value === MeasoftCourier::PAYMENT_TYPE_NONE) {
                        $none_pay[] = $key;
                    }
                }
            }

            $options = array(
                'card'      => $card_pay,
                'cash'      => $cash_pay,
                'no'        => $none_pay
            );

            if( update_option('measoft_pay_types', $options) ) {
                wp_send_json(
                    array(
                        'status'            => 'success',
                        'measoft_pay_types' => get_option('measoft_pay_types')
                    ),
                    200
                );
            }
        }

        wp_send_json(
            array(
                'status' => 'failed'
            ),
            200
        );
    }

    public function setPayType()
    {
        $payType = !empty($_POST['paytype']) ? $_POST['paytype'] : null;

        if(!is_null($payType) && isset(WC()->session)) {
            WC()->session->set( 'chosen_payment_method', $payType);

            wp_send_json(
                array(
                    'status'                => 'success',
                    'chosen_payment_method' => WC()->session->get( 'chosen_payment_method')
                ),
                200
            );
        }

        wp_send_json(
            array(
                'status' => 'failed'
            ),
            200
        );
    }
}