jQuery(document).ready(function() {
	

    jQuery('body').on('change', 'input[name="payment_method"]', function (e) {

        jQuery('#payment').block({ message: null });

        jQuery.ajax({
            type: "POST",
            url: myajax.url,
            data: {
                action		: 'measoft_pay_type_set',
                paytype     : jQuery('input[name="payment_method"]:checked').val()
            },
            success: function(response) {
                jQuery('#payment').unblock();
                jQuery('body').trigger('update_checkout');
            }
        });
    });

    jQuery('#calc_shipping_city, #billing_city, #shipping_city').autocomplete({
        minChars: 2,
        source: function(term, suggest) {
            try {
                searchRequest.abort();
            } catch (e) {}
            searchRequest = jQuery.post(myajax.url, {
                search: term,
                action: 'ks2008_city_autocomplete'
            }, function(res) {
                suggest(res.data);
            });
        }
    });

    jQuery('#billing_address_1, #shipping_address_1').autocomplete({
        minChars: 2,
        source: function(term, suggest) {
            try {
                searchRequest.abort();
            } catch (e) {}
            var town = jQuery('#' + _getCityFieldId()).val();   
			
            searchRequest = jQuery.post(myajax.url, {
                search: term,
                town: town,
                action: 'ks2008_adress_autocomplete'
            }, function(res) {
                suggest(res.data);
            });
        }
    });

    jQuery('body').on('click', '.ui-menu-item', function() {
        jQuery(document.body).trigger("update_checkout");
    });

    function isMeaPickupChecked() { 
        let result = false;

        if (
            jQuery('.woocommerce-shipping-methods input[value="KC2008_Pickup_Method"]').is(':checked')
            ||
            ((jQuery('.woocommerce-shipping-methods input').length == 1) && (jQuery('.woocommerce-shipping-methods input').val() == 'KC2008_Pickup_Method'))
        ) {
            result = true;
        }

        return result;
    }

    jQuery('.woocommerce-shipping-methods input').on('change', function() {
        if (jQuery(this).val() == 'KC2008_Pickup_Method') {
            jQuery('.ks2008_pvzname, .ks2008_pvzcode,').css('display', 'block');
        }
    });

	setInterval(() => { 
		if (isMeaPickupChecked()) {
			jQuery('.ks2008_pvzname, .ks2008_pvzcode').css('display', 'block');
		} 
	}, 500);
    

    jQuery(document.body).on("update_checkout", function() {
		
        if (isMeaPickupChecked()) {
            jQuery('.ks2008_pvzname, .ks2008_pvzcode').css('display', 'block');
        } else {
            jQuery('.ks2008_pvzname, .ks2008_pvzcode').css('display', 'none');
        }
    });

	
    var billing_city = document.querySelector('#' + _getCityFieldId());



    if (jQuery('#ks2008_pvz_map_block').length > 0) {
        if (!ks2008client.weight) {
            ks2008client.weight = 0.1;
        }

        if (billing_city.value != '') {


            var measoftObject = measoftMap.config({
                'pvzCodeSelector': '#pvzcode',
                'mapSearchZoom': 10,
                'pvzAddressSelector': '#pvzname',
                'mapBlock': 'ks2008_pvz_map_block',				
                'townBlock': _getCityFieldId(),
                'windowFixedPosition': 1,
                'client_id': ks2008client.id, // Сюда нужно указать код extra курьерской службы
				'client_code': ks2008client.code,
                'mapSize': { // Размер карты
                    'width': ks2008client.map_width,
                    'height': ks2008client.map_height
                },
                'centerCoords': ['55.755814', '37.617635'],
                'showMapButton': '1',
                'showMapButtonCaption': ks2008client.choosepickuppoint,
                'filter': {
                    'acceptcard': 'YES',
                    'maxweight': ks2008client.weight
                },
                'allowedFilterParams': ['acceptcash', 'acceptcard', 'acceptfitting'],
				'choicePvzCallback': function(code){

                         var pvzData = measoftMap.getSelectedPvzData();

                         jQuery.post(myajax.url, {
                              townCode: jQuery('#pvz_towncode').val() || '',
                              pvzData: pvzData,
                              townto: jQuery('#' + _getCityFieldId()).val() || '',
                              action: 'ks2008_recalc'
                         }, function(resp){
                              jQuery('body').trigger('update_checkout');
                         });

                    },
            }).init();
        } else {
            var measoftObject = measoftMap.config({
                'pvzCodeSelector': '#pvzcode',
                'mapSearchZoom': 10,
                'pvzAddressSelector': '#pvzname',
                'mapBlock': 'ks2008_pvz_map_block',
				'windowFixedPosition': 1,
                'client_id': ks2008client.id, // Сюда нужно указать код extra курьерской службы
				'client_code': ks2008client.code,
                'mapSize': { // Размер карты
                    'width': ks2008client.map_width,
                    'height': ks2008client.map_height
                },
                'centerCoords': ['55.755814', '37.617635'],
                'showMapButton': '1',
                'showMapButtonCaption': ks2008client.choosepickuppoint,
                'filter': {
                    'acceptcard': 'YES',
                    'maxweight': ks2008client.weight
                },
                'allowedFilterParams': ['acceptcash', 'acceptcard', 'acceptfitting'],
				'choicePvzCallback': function(code){
				

                         var pvzData = measoftMap.getSelectedPvzData();

                         jQuery.post(myajax.url, {
                              townCode: jQuery('#pvz_towncode').val() || '',
                              pvzData: pvzData,
                              townto: jQuery('#' + _getCityFieldId()).val() || '',
                              action: 'ks2008_recalc'
                         }, function(resp){
                              jQuery('body').trigger('update_checkout');
                         });

                },
            }).init();
        }

        var ks2008_pvz_checkout = jQuery('#ks2008_pvz_checkout');	
       
		
            ks2008_pvz_checkout.css('display', 'block');
            var ks2008_pvz_map_block = jQuery('#ks2008_pvz_map_block');
            jQuery('#ks2008_pvz_map_block').remove();
            jQuery('.ks2008_pvzcode').append(ks2008_pvz_map_block);
			
			 


        jQuery("#pvzcode").change(function() {

            var $this = jQuery(this);

            if (jQuery("select#pvz_select option[value='" + $this.val() + "']").length > 0) {
                jQuery("select#pvz_select").val($this.val());
            } else {
                setTimeout(function() {
                    jQuery("select#pvz_select").append('<option value="' + $this.val() + '">' + jQuery('#pvzname').val() + '</option>');
                    jQuery("select#pvz_select").val($this.val());
                }, 1000);
            }
        });
    }

    // visual reforming on client side
    if (document.querySelector('#pvzname_field')) {
        let pvzcode_field = document.querySelector('#pvzcode_field');
        let pvzname_field = document.querySelector('#pvzname_field');
        let pvzname = document.querySelector('#pvzname');
        let map_block = document.querySelector('#ks2008_pvz_map_block');
        let reset_btn = document.createElement('div');
        reset_btn.classList.add('reset_btn');       
        let resultBlock = document.createElement('div');
        resultBlock.classList.add('resultBlock');
        pvzname.setAttribute('readonly', 'true');
        pvzname.setAttribute('placeholder', '');
        pvzname_field.insertAdjacentElement('beforeend', resultBlock);

        resultBlock.appendChild(pvzname);
        resultBlock.appendChild(map_block);
        resultBlock.appendChild(reset_btn);

        billing_city.addEventListener('change', resetMap);

        reset_btn.addEventListener('click', function() {
            pvzname.value = '';
        });
		
		
	
		
		
    }

    function resetMap() {
        var measoftObject = measoftMap.config({
            'pvzCodeSelector': '#pvzcode',
            'mapSearchZoom': 10,
            'pvzAddressSelector': '#pvzname',
            'mapBlock': 'ks2008_pvz_map_block',
			'windowFixedPosition': 1,
            'townBlock': _getCityFieldId(),
            'client_id': ks2008client.id, // Сюда нужно указать код extra курьерской службы
			'client_code': ks2008client.code,
            'mapSize': { // Размер карты
                'width': ks2008client.map_width,
                'height': ks2008client.map_height
            },
            'centerCoords': ['55.755814', '37.617635'],
            'showMapButton': '1',
            'showMapButtonCaption': ks2008client.choosepickuppoint,
            'filter': {
                'acceptcard': 'YES',
                'maxweight': ks2008client.weight
            },
            'allowedFilterParams': ['acceptcash', 'acceptcard', 'acceptfitting'],
			'choicePvzCallback': function(code){
					

                         var pvzData = measoftMap.getSelectedPvzData();

                         jQuery.post(myajax.url, {
                              townCode: jQuery('#pvz_towncode').val() || '',
                              pvzData: pvzData,
                              townto: jQuery('#' + _getCityFieldId()).val() || '',
                              action: 'ks2008_recalc'
                         }, function(resp){
                              jQuery('body').trigger('update_checkout');
                         });

            },
        }).init();
    }

    jQuery(document).on('change', '#pvzname', function(){
        if (isMeaPickupChecked()) {
            jQuery('#billing_address_1, #shipping_address_1').val(jQuery(this).val());
        }
    });
	
	function _getCityFieldId(){
		let result = '';
		if (jQuery('#billing_city').length){
			result = 'billing_city';	
		}else{
			result = 'shipping_city';
		}	
		return result;		
	}	

});
